"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const propertyListener_1 = require("../Store/propertyListener");
const hasIntersection = (set1, set2) => {
    const smallestSet = set1.size < set2.size ? set1 : set2;
    const biggestSet = set1 === smallestSet ? set2 : set1;
    let result = false;
    smallestSet.forEach((key) => {
        if (biggestSet.has(key)) {
            result = true;
        }
    });
    return result;
};
let activePropertyListener;
exports.createHook = (store) => {
    const useStore = () => {
        const [listenObject] = react_1.useState(propertyListener_1.propertyListener(store.getState()));
        const [state, setState] = react_1.useState(listenObject.getProxy());
        const stopListenProperty = () => {
            listenObject.stop();
        };
        if (activePropertyListener) {
            activePropertyListener();
            activePropertyListener = stopListenProperty;
        }
        react_1.useEffect(() => {
            return store.subscribe((newState, changedProps) => {
                if (hasIntersection(changedProps, listenObject.getUsedkeys())) {
                    if (activePropertyListener === stopListenProperty) {
                        activePropertyListener();
                        activePropertyListener = undefined;
                    }
                    setState(newState);
                }
            });
        }, []);
        return Object.assign(Object.assign({}, state), store.actions);
    };
    return { useStore };
};
